{% extends 'ucs_besplusplus/base.html' %}
{% load ucs_besplusplus %}
{% load lazy %}
{% load staticfiles %}
{% block head_title %}Bes++ resource {{resource}}{% endblock %}
{% block static_breadcrumbs %}
  {{block.super}}<li>{{resource}}</li>
{% endblock %}
{% block content_column_1 %}
  <div class="campl-column9 campl-main-content">
    <div class="campl-content-container">
      <h1>{{resource}}</h1>
      {% include "ucamprojectlight-messages.html" %}
      {# Simple attributes #}
      {% if resource.fwd.sysadmin|add:resource.fwd.vmware_user %}
      <dl>
      <dt>Sysadmin:</dt>
	<dd>
      <ul>
	{% for sysadmin in resource.fwd.sysadmin %}
	<li><a href="{{sysadmin|lookup_url}}">{% if user.is_authenticated %}{{sysadmin|lookup_name}}{% else %}{{sysadmin}}{% endif %}</a></li>
	{% endfor %}
	{% for sysadmin in resource.fwd.vmware_user %}
	<li><a href="{{sysadmin|lookup_url}}">{% if user.is_authenticated %}{{sysadmin|lookup_name}}{% else %}{{sysadmin}}{% endif %}</a> (VMware)</li>
	{% endfor %}
      </ul>
	  </dd></dl>
      {% endif %}
      {% include "ucs_besplusplus/resource_hierarchy.html" %}
      {% for comment in resource.fwd.comment %}
      {{ comment|linebreaks }}
      {% endfor %}
      {% for note in resource.fwd.vmware_notes %}
      {{ note|linebreaks }}
      {% endfor %}
      {% if "dkx2" in resource.fwd.type %}
      <p>This is a <a href="https://wiki.cam.ac.uk/ucs/Dominion_KX_II">
	  Raritan Dominion KX II</a> network KVM switch.</p>
      {% if resource.fwd.dkx2_cim %}
      <h2>Attached CIMs</h2>
      <p>These CIMs are attached to {{resource}}:</p>
      <table summary="" class="campl-table-bordered campl-table-striped
	campl-table  campl-vertical-stacking-table">
	<thead>
	  <tr><th>Label</th><th>CIM serial number</th>
	    <th>Connected box</th></tr>
	</thead>
	<tbody>
	  {% for cim in resource.fwd.dkx2_cim %}
	  <tr>
	    <td>{{ cim.fwd.label|join:" " }}</td>
	    <td><a href="{% url 'resource' cim.id %}">
		{% for serial in cim.fwd.serial_number %}{{serial}}<br />{% endfor %}
	      </a></td>
	    <td>{% for resource in cim.rev.console %}
		{% include "ucs_besplusplus/resource_snippet.html" %}<br />
		{% endfor %}
	    </td>
	  </tr>
	  {% endfor %}
	</tbody>
      </table>
      {% endif %}
      {% endif %}
      {% if "pdu" in resource.fwd.type %}
      <p>This is a power distribution unit.</p>
      {% if resource.fwd.incorporates %}
      <h2>Outlets</h2>
      <p>These boxes are powered by {{resource}}:</p>
      <table summary="" class="campl-table-bordered campl-table-striped
	campl-table  campl-vertical-stacking-table">
	<thead>
	  <tr><th>Outlet</th><th>Connected box</th></tr>
	</thead>
	<tbody>
	  {% for outlet in resource.fwd.incorporates %}
	  {% if "pdu-outlet" in outlet.fwd.type %}
	  <tr>
	    <td><a href="{% url 'resource' outlet.id %}">
	        {{ outlet.fwd.label|join:" " }}</a></td>
	    <td>{% for resource in outlet.fwd.powers %}
		{% include "ucs_besplusplus/resource_snippet.html" %}<br />
		{% endfor %}
	    </td>
	  </tr>
	  {% endif %}
	  {% endfor %}
	</tbody>
      </table>
      {% endif %}
      {% endif %}
      {% if "rack" in resource.fwd.type %}
      <h2>Contents</h2>
      <p>This rack contains:</p>
      {% rack_snippet resource %}
      {% endif %}
      {% if resource.fwd.console %}
      <h2>Console access to {{resource}}</h2>
      {% for console in resource.fwd.console %}
      {% if 'dkx2-cim' in console.fwd.type %}
      {% for kvm in console.rev.dkx2_cim %}
      <p>This box is connected to
	{% include "ucs_besplusplus/resource_snippet.html" with resource=kvm %}.
	{% if kvm.fwd.infra_gateway %}
	To access it, you will need to log into
	{% include "ucs_besplusplus/infra_gateway_snippet.html" with infra_gateway=kvm.fwd.infra_gateway.0 %}
	and run <code>raritan-mpc</code>.
	{% endif %}
      </p>
      {% endfor %}
      {% endif %}
      {% if 'vcenter' in console.fwd.type and 'https://vc.csi.cam.ac.uk/sdk/vimService' in console.fwd.vcenter_url %}
      <p>This is a VMware virtual machine.  Its console can be accessed
	through Platforms’ vCenter.
        You will need to use your Desktop Services or UCS password to log
	in.</p>
      <p><a class="campl-primary-cta"
	  href="https://bes.csi.cam.ac.uk/vmrc/index.html?vm={{ resource.fwd.label.0|urlencode }}&amp;vmid={{ resource.fwd.vmware_mo_ref.0|urlencode }}">Request console</a>
      </p>
      {% endif %}
      {% endfor %}
      {% endif %}
      {% lazy %}
      <h2>Power</h2>
      <p>{{resource}} is powered by:</p>
      <ul>
	{% content %}
	{% for resource in resource.rev.powers %}
	<li>{% include "ucs_besplusplus/resource_snippet.html" %}</li>
	{% endfor %}
	{% for resource in resource.fwd.incorporates %}
	{% for resource in resource.rev.powers %}
	<li>{% include "ucs_besplusplus/resource_snippet.html" %}</li>
	{% endfor %}
	{% endfor %}
	{% endcontent %}
      </ul>
      {% endlazy %}
      <h2>Properties of this resource</h2>
      <ul>
	{% for property in resource.properties_rev.all %}
        <li>{% include "ucs_besplusplus/property_snippet.html" %}</li>
	{% endfor %}
	{% for property in resource.properties_fwd.all %}
	<li>{% include "ucs_besplusplus/property_snippet.html" %}
	  {% if property.predicate == 'incorporates' and property.object_res != None %}
	  {# Arbitrarily-deep nesting might be nice here, but then we'd have #}
	  {# to detect loops. #}
	  <ul>
	    {% for property in property.object_res.properties_fwd.all %}
	    <li>{% include "ucs_besplusplus/property_snippet.html" %}</li>
	    {% endfor %}
	    {% for property in property.object_res.properties_rev.all %}
	    {% if property.predicate != 'incorporates' and property.subject != resource %}
	    <li>{% include "ucs_besplusplus/property_snippet.html" %}</li>
	    {% endif %}
	    {% endfor %}
	  </ul>
	  {% endif %}
	</li>
	{% endfor %}
      </ul>
      <p><a class="campl-primary-cta" 
	  href="{% url 'edit' resource.id %}">Edit</a></p>
      <h2>Recent changes</h2>
      {% include "ucs_besplusplus/history_snippet.html" %}
      <p><a class="campl-secondary-cta"
	  href="{% url 'resource_history' resource.id %}">Full history</a></p>
      <p><a href="{% url 'jsonld' resource.id %}" class="campl-icon-link"
	  rel="alternate" type="application/ld+json">
	  <span class="campl-icon besplusplus-jsonld-icon"></span>JSON-LD data</a></p>
    </div>
  </div>
{% endblock %}
{% block right_column %}
{{block.super}}
{% lazy %}
  <div class="campl-content-container">
    <div class="campl-heading-container">
      <h2>Related links for {{ resource }}</h2>
    </div>
    <ul class="campl-unstyled-list campl-related-links">
      {% content %}
      {% for l in related_links %}
      <li><a href="{{ l.url }}"
	  class="campl-secondary-cta">{{ l.label }}</a></li>
      {% endfor %}
      {% for console in resource.fwd.console %}
      {% if 'vcenter' in console.fwd.type and 'https://vc.csi.cam.ac.uk/sdk/vimService' in console.fwd.vcenter_url %}
      <li><a class="campl-secondary-cta"
	  href="https://bes.csi.cam.ac.uk/vmrc/index.html?vm={{ resource.fwd.label.0|urlencode }}&amp;vmid={{ resource.fwd.vmware_mo_ref.0|urlencode }}">VMware console</a>
      </li>
      {% endif %}
      {% endfor %}
      {% endcontent %}
    </ul>
  </div>
{% endlazy %}
{% endblock %}
